VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private WithEvents hParent  As VB.PictureBox
Attribute hParent.VB_VarHelpID = -1

Private Type LISTVIEWITEM ' 8 bytes + Len(vText)
    vHeight          As Long
    vTop             As Long
    vText            As String
End Type
Private Const SizeOfLISTVIEWITEM As Long = 8 ' + Len(vText)

Private m_Item()     As LISTVIEWITEM
Private m_ItemCount  As Long

Private m_ListLeft   As Single
Private m_ListTop    As Single
Private m_ListWidth  As Single
Private m_ListHeight As Single

Private m_ScrollPos      As Long 'index of the item at the top of the list
Private m_ScrollTabs     As Long 'number of max, for a scroll bar
Private m_ScrollMaxPos   As Long 'Max position we can scroll to
Private m_ScrollEndPos   As Long 'Position of the bottom item in the *visible* list

Private m_SelectedIndex  As Integer
Private m_HoverSelect    As Boolean
Private m_MouseX        As Single
Private m_MouseY        As Single
Public Event ReDraw(ByVal StartIndex As Long, ByVal EndIndex As Long)
Public Event ItemDblClick(ByVal Index As Long)
Public Event ItemMouseMove(ByVal Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event ItemMouseDown(ByVal Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event ItemMouseUp(ByVal Index As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)

Public m_GlobalHeight As Long

Private m_NeedReDraw  As Boolean

Public Property Get Parent() As PictureBox
    Set Parent = hParent
End Property
Public Property Set Parent(ByRef vNewParent As PictureBox)
    Set hParent = vNewParent
    'hParent.ScaleMode = 3 'vbPixels
End Property

Public Property Get Left() As Single:        Left = m_ListLeft:      End Property
Public Property Get Top() As Single:         Top = m_ListTop:        End Property
Public Property Get Width() As Single:       Width = m_ListWidth:    End Property
Public Property Get Height() As Single:      Height = m_ListHeight:  End Property


Public Sub Move(ByVal lngLeft As Long, ByVal lngTop As Long, ByVal lngWidth As Long, ByVal lngHeight As Long)
    m_ListLeft = lngLeft
    m_ListTop = lngTop
    m_ListWidth = lngWidth
    m_ListHeight = lngHeight
    Call ResortScrollCount
End Sub
Public Property Let Left(ByVal vNewValue As Single)
    m_NeedReDraw = (Not m_ListLeft = vNewValue)
    m_ListLeft = vNewValue
    Call RequestReDraw
End Property
Public Property Let Top(ByVal vNewValue As Single)
    m_NeedReDraw = (Not m_ListTop = vNewValue)
    m_ListTop = vNewValue
    Call RequestReDraw
End Property
Public Property Let Width(ByVal vNewValue As Single)
    m_NeedReDraw = (Not m_ListWidth = vNewValue)
    m_ListWidth = vNewValue
    Call RequestReDraw
End Property
Public Property Let Height(ByVal vNewValue As Single)
    m_NeedReDraw = (Not m_ListHeight = vNewValue)
    m_ListHeight = vNewValue
    Call ResortScrollCount
End Property




Public Property Get ItemHeight(ByVal Index As Long) As Long
    If Index < 0 Or Index > m_ItemCount Then Exit Property
    ItemHeight = m_Item(Index).vHeight
End Property
Public Property Let ItemHeight(ByVal Index As Long, ByVal vNewValue As Long)
    If Index < 0 Or Index > m_ItemCount Then Exit Property
    If vNewValue < 1 Then vNewValue = 1
    m_NeedReDraw = (Not m_Item(Index).vHeight = vNewValue)
    m_Item(Index).vHeight = vNewValue
    Call ResortScrollCount
End Property
Public Property Get ItemTop(ByVal Index As Long) As Long
    If Index < 0 Or Index > m_ItemCount Then Exit Property
    ItemTop = m_Item(Index).vTop
End Property
Public Property Get ItemText(ByVal Index As Long) As String
    If Index < 0 Or Index > m_ItemCount Then Exit Property
    ItemText = m_Item(Index).vText
End Property
Public Property Get ItemCount() As Long
    ItemCount = m_ItemCount
End Property


Public Property Get ScrollVisible() As Boolean:         ScrollVisible = (m_ScrollTabs > 0):   End Property
Public Property Get ScrollTabs() As Long:               ScrollTabs = m_ScrollTabs:            End Property
Public Property Get ScrollMaxIndex() As Long:           ScrollMaxIndex = m_ScrollMaxPos:      End Property
Public Property Get ScrollIndex() As Long:              ScrollIndex = m_ScrollPos:            End Property
Public Property Let ScrollIndex(ByVal vNewValue As Long)
    m_NeedReDraw = (Not m_ScrollPos = vNewValue)
    m_ScrollPos = vNewValue
    Call RequestReDraw
    'Call ResortScrollCount
End Property

Public Property Get SelectedIndex() As Long:            SelectedIndex = m_SelectedIndex:      End Property
Public Property Let SelectedIndex(ByVal vNewValue As Long)
    m_NeedReDraw = (Not m_SelectedIndex = vNewValue)
    m_SelectedIndex = vNewValue
    If m_SelectedIndex < -1 Then m_SelectedIndex = -1
    If m_SelectedIndex > m_ItemCount Then m_SelectedIndex = m_ItemCount
    Call RequestReDraw
End Property

Public Property Get HoverSelection() As Boolean:        HoverSelection = m_HoverSelect:       End Property
Public Property Let HoverSelection(ByVal vNewValue As Boolean): m_HoverSelect = vNewValue: End Property


Public Sub Refresh()
    m_NeedReDraw = True
    Call ResortScrollCount
End Sub

Private Sub RequestReDraw()
    If m_NeedReDraw Then
        m_NeedReDraw = False
        Dim i As Long
        Dim lngTop As Long
        For i = m_ScrollPos To m_ItemCount
            m_Item(i).vTop = lngTop
            lngTop = lngTop + m_Item(i).vHeight
            If (lngTop >= m_ListHeight) Then
                'end drawing at this index
                Exit For
            End If
        Next i
        If i > m_ItemCount Then i = m_ItemCount
        m_ScrollEndPos = i
        
        'If hParent.Visible = False Then Exit Sub
        
        RaiseEvent ReDraw(m_ScrollPos, m_ScrollEndPos)
    End If
End Sub

Public Function GetVisibleIndex(ByVal Index As Long) As Long
    'Take an index, fine a visible place and return the scroll position
    Dim i           As Long
    Dim lngTop      As Long
    If ((Index < 0) Or (Index > m_ItemCount)) Then
        GetVisibleIndex = -1
        Exit Function
    ElseIf ((Index >= m_ScrollPos) And (Index <= m_ScrollEndPos)) Then
        GetVisibleIndex = -1
        Exit Function 'out of range, or already visible
    End If
GetVisibleIndexAgain:
    lngTop = 0
    For i = Index To m_ItemCount
        lngTop = lngTop + m_Item(i).vHeight
        If (lngTop > m_ListHeight) Then
            '//It fits here nicely
            'Me.ScrollIndex = Index
            GetVisibleIndex = Index
            Exit Function
        End If
    Next i
    Index = Index - 1
    If (Index < 0) Then
        '//Finished
        'Me.ScrollIndex = 0
        GetVisibleIndex = 0
        Exit Function
    End If
    GoTo GetVisibleIndexAgain
    
    'Call ResortScrollCount(True)
    'm_NeedReDraw = True
    Call RequestReDraw
End Function

Public Function AddItem(ByVal strItem As String, Optional ByVal Index As Long = -1, Optional ByVal lngHeight As Long = 40, Optional ByVal bReDraw As Boolean = True) As Long
    On Error GoTo AddItemAbort
    If (Index > (m_ItemCount + 1)) Then GoTo AddItemAbort
    If lngHeight < 1 Then lngHeight = 1
    Dim i     As Long
    m_ItemCount = m_ItemCount + 1
    ReDim Preserve m_Item(m_ItemCount)
    i = m_ItemCount
    If (Index >= 0) And (Not Index = m_ItemCount) Then
        For i = (m_ItemCount - 1) To Index Step -1
            m_Item(i + 1) = m_Item(i)
        Next i
        i = Index
    End If
    m_Item(i).vHeight = lngHeight
    m_Item(i).vText = strItem
    m_Item(i).vTop = (-20 + -lngHeight) 'hide this item
    m_GlobalHeight = m_GlobalHeight + lngHeight
    m_NeedReDraw = bReDraw
    If bReDraw Then
        Call ResortScrollCount
    End If
    m_NeedReDraw = True
    AddItem = i
    Exit Function
AddItemAbort:
    AddItem = -1
End Function
Public Sub RemoveItem(ByVal Index As Long)
    If Index < 0 Or Index > m_ItemCount Then Exit Sub
    '//lower the scroll view position if needed
    If Index <= m_ScrollPos Then Me.ScrollIndex = Me.ScrollIndex - 1
    '//lower the selected index if needed
    If Index = m_SelectedIndex Then m_SelectedIndex = -1
    If Index < m_SelectedIndex Then m_SelectedIndex = m_SelectedIndex - 1
    '//lower the global height
    m_GlobalHeight = m_GlobalHeight - m_Item(Index).vHeight
    Dim i As Long
    If Not Index = m_ItemCount Then
        For i = Index To (m_ItemCount - 1)
            m_Item(i) = m_Item(i + 1)
        Next i
    End If
    m_ItemCount = m_ItemCount - 1
    If m_ItemCount < 0 Then
        m_ItemCount = -1
        Erase m_Item()
    Else
        ReDim Preserve m_Item(m_ItemCount) 'remove the last place
    End If
    m_NeedReDraw = True
    Call ResortScrollCount
End Sub
Public Function FindItem(ByRef strItemName As String) As Long
    Dim i As Long
    For i = 0 To m_ItemCount
        If StrComp(m_Item(i).vText, strItemName, vbTextCompare) = 0 Then
            FindItem = i
            Exit Function
        End If
    Next i
    FindItem = -1
End Function
Public Sub Clear()
    m_NeedReDraw = (m_ItemCount >= 0)
    Call Class_Terminate
    Call ResortScrollCount
End Sub


Private Sub ResortScrollCount(Optional ByVal bReDraw As Boolean = True)
    'this sub calculates the max scroll position, and the number of needed scroll tabs
    Dim i      As Long
    Dim lngTop As Long
    Dim lngMax As Long
    Dim lngTab As Long
    
    lngTop = 0
    lngMax = m_ScrollMaxPos
    lngTab = m_ScrollTabs
    m_ScrollMaxPos = 0
    m_ScrollTabs = 0
    
    For i = m_ItemCount To 0 Step -1
        If (lngTop + m_Item(i).vHeight) > m_ListHeight Then
            'this is the max scroll item index (cant go higher)
            m_ScrollMaxPos = (i + 1)
            Exit For
        End If
        m_ScrollTabs = m_ScrollTabs + 1
        lngTop = lngTop + m_Item(i).vHeight
    Next i
    m_ScrollTabs = ((m_ItemCount + 1) - m_ScrollTabs)
    If m_ScrollTabs < 0 Then
        m_ScrollTabs = 0
        m_NeedReDraw = bReDraw
    End If
    If m_ScrollPos < 0 Then
        m_ScrollPos = 0
        m_NeedReDraw = bReDraw
    End If
    If m_ScrollPos > m_ScrollMaxPos Then
        m_ScrollPos = m_ScrollMaxPos
        m_NeedReDraw = bReDraw
    End If
    If Not m_ScrollTabs = lngTab Then m_NeedReDraw = bReDraw
    If Not m_ScrollMaxPos = lngMax Then m_NeedReDraw = bReDraw
    Call RequestReDraw
End Sub





Private Sub Class_Initialize()
    Call Class_Terminate
    Call ResortScrollCount
End Sub
Private Sub Class_Terminate()
    m_SelectedIndex = -1
    m_ItemCount = -1
    Erase m_Item()
End Sub





Private Sub hParent_DblClick()
    Dim i As Long
    If InRangeWithMe(m_MouseX, m_MouseY) = False Then Exit Sub
    i = FindItemIndex(m_MouseY)
    If (i = -1) Then Exit Sub
    RaiseEvent ItemDblClick(i)
End Sub

Private Sub hParent_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_MouseX = X
    m_MouseY = Y
    If InRangeWithMe(X, Y) = False Then Exit Sub
    Dim i As Long
    i = FindItemIndex(Y)
    If (i = -1) Then
        RaiseEvent ItemMouseDown(i, Button, Shift, X, Y)
    Else
        m_NeedReDraw = (Not m_SelectedIndex = i)
        m_SelectedIndex = i
        RaiseEvent ItemMouseDown(i, Button, Shift, (X - m_ListLeft), (Y - m_ListTop) - m_Item(i).vTop)
    End If
    Call RequestReDraw
End Sub
Private Sub hParent_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_MouseX = X
    m_MouseY = Y
    If InRangeWithMe(X, Y) = False Then Exit Sub
    Dim i As Long
    i = FindItemIndex(Y)
    If m_HoverSelect Then
        If (i = -1) Then
            RaiseEvent ItemMouseMove(i, Button, Shift, X, Y)
        Else
            m_NeedReDraw = (Not m_SelectedIndex = i)
            m_SelectedIndex = i
            RaiseEvent ItemMouseMove(i, Button, Shift, (X - m_ListLeft), (Y - m_ListTop) - m_Item(i).vTop)
        End If
        Call RequestReDraw
    Else
        If (i = -1) Then
            RaiseEvent ItemMouseMove(i, Button, Shift, X, Y)
        Else
            RaiseEvent ItemMouseMove(i, Button, Shift, (X - m_ListLeft), (Y - m_ListTop) - m_Item(i).vTop)
        End If
    End If
End Sub
Private Sub hParent_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_MouseX = X
    m_MouseY = Y
    If InRangeWithMe(X, Y) = False Then Exit Sub
    Dim i As Long
    i = FindItemIndex(Y)
    If m_HoverSelect Then
        If (i = -1) Then
            RaiseEvent ItemMouseUp(i, Button, Shift, X, Y)
        Else
            m_NeedReDraw = (Not m_SelectedIndex = i)
            m_SelectedIndex = i
            RaiseEvent ItemMouseUp(i, Button, Shift, (X - m_ListLeft), (Y - m_ListTop) - m_Item(i).vTop)
        End If
        Call RequestReDraw
    Else
        If (i = -1) Then
            RaiseEvent ItemMouseUp(i, Button, Shift, X, Y)
        Else
            RaiseEvent ItemMouseUp(i, Button, Shift, (X - m_ListLeft), (Y - m_ListTop) - m_Item(i).vTop)
        End If
    End If
End Sub

Private Function InRangeWithMe(X As Single, Y As Single) As Boolean
    If X < m_ListLeft Then Exit Function
    If X > m_ListLeft + m_ListWidth Then Exit Function
    If Y < m_ListTop Then Exit Function
    If Y > m_ListTop + m_ListHeight Then Exit Function
    InRangeWithMe = True
End Function
Private Function FindItemIndex(Y As Single) As Long
    Dim i As Long
    For i = m_ScrollPos To m_ScrollEndPos
        If (Y >= (m_ListTop + m_Item(i).vTop)) And _
           (Y <= (m_ListTop + m_Item(i).vTop + m_Item(i).vHeight)) Then
            FindItemIndex = i
            Exit Function
        End If
    Next i
    FindItemIndex = -1
End Function


